﻿using EndMove.Sudoku.Solver.Core.Algorithms;
using EndMove.Sudoku.Solver.Core.Common;

namespace EndMove.Sudoku.Solver.Core
{
    public static class Program
    {
        public static void Main(string[] args)
        {
            var store = new SudokuStore();
            store.AddBoard(new[,]
            {
                { 5, 3, 0, 0, 7, 0, 0, 0, 0 },
                { 6, 0, 0, 1, 9, 5, 0, 0, 0 },
                { 0, 9, 8, 0, 0, 0, 0, 6, 0 },
                { 8, 0, 0, 0, 6, 0, 0, 0, 3 },
                { 4, 0, 0, 8, 0, 3, 0, 0, 1 },
                { 7, 0, 0, 0, 2, 0, 0, 0, 6 },
                { 0, 6, 0, 0, 0, 0, 2, 8, 0 },
                { 0, 0, 0, 4, 1, 9, 0, 0, 5 },
                { 0, 0, 0, 0, 8, 0, 0, 7, 9 }
            }, new[,]
            {
                { 8, 0, 0, 0, 0, 0, 0, 0, 0 },
                { 0, 0, 3, 6, 0, 0, 0, 0, 0 },
                { 0, 7, 0, 0, 9, 0, 2, 0, 0 },
                { 0, 5, 0, 0, 0, 7, 0, 0, 0 },
                { 0, 0, 0, 0, 4, 5, 7, 0, 0 },
                { 0, 0, 0, 1, 0, 0, 0, 3, 0 },
                { 0, 0, 1, 0, 0, 0, 0, 6, 8 },
                { 0, 0, 8, 5, 0, 0, 0, 1, 0 },
                { 0, 9, 0, 0, 0, 0, 4, 0, 0 }
            },
            new[,]
            {
                { 0, 0, 5, 3, 0, 0, 0, 0, 0 },
                { 8, 0, 0, 0, 0, 0, 0, 2, 0 },
                { 0, 7, 0, 0, 1, 0, 5, 0, 0 },
                { 4, 0, 0, 0, 0, 5, 3, 0, 0 },
                { 0, 1, 0, 0, 7, 0, 0, 0, 6 },
                { 0, 0, 3, 2, 0, 0, 0, 8, 0 },
                { 0, 6, 0, 5, 0, 0, 0, 0, 9 },
                { 0, 0, 4, 0, 0, 0, 0, 3, 0 },
                { 0, 0, 0, 0, 0, 9, 7, 0, 0 }
            },
            new[,]
            {
                { 0, 0, 0, 0, 0, 7, 0, 9, 0 },
                { 2, 0, 0, 0, 0, 8, 0, 0, 0 },
                { 0, 3, 0, 0, 0, 0, 0, 6, 0 },
                { 0, 0, 0, 5, 0, 0, 0, 0, 9 },
                { 0, 0, 1, 0, 0, 0, 0, 0, 0 },
                { 9, 0, 0, 0, 0, 0, 0, 0, 0 },
                { 0, 0, 0, 0, 0, 0, 0, 0, 0 },
                { 0, 0, 0, 0, 6, 0, 0, 0, 0 },
                { 0, 5, 0, 0, 9, 0, 0, 0, 0 }
            });

            SudokuUtils.TwoDTo1D(store[0], out int[] sudoku1D);
            SudokuUtils.DisplayBoard(sudoku1D);
            // TODO 1D solver with backtracking

            ISolver solver = new BackTrackingSolver(SudokuUtils.DisplayBoard);
            var (status, lol) = solver.Solve(store[0]);
            Console.WriteLine(status);
        }
    }
}